﻿using System.Collections.Generic;
using System.Windows;
using System.Windows.Input;
using HierarchyConverter.Wpf.Sample.ViewModels;
using Telerik.Windows.Controls;
using System.Linq;

namespace HierarchyConverter.Wpf.Sample
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		FolderConverter converter;

		public Window1()
		{
			InitializeComponent();

			converter = this.Resources["folderHierarchyConverter"] as FolderConverter;

			converter.ItemsSource = FolderViewModel.Generate();

			this.AddHandler(UIElement.MouseRightButtonUpEvent, new MouseButtonEventHandler(OnRightClick));

		}

		private void OnRightClick(object sender, MouseButtonEventArgs e)
		{
			ContextMenuBuilder.OpenContextMenu(e.OriginalSource as UIElement);
		}
	}

	public class FolderConverter : ReverseHierarchyConverter<FolderViewModel, int>
	{
		public FolderConverter()
		{
			this.Initialize(f => f.Id, f => f.ParentId, 0, -1);
		}
	}
}
