﻿using HierarchyConverter;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections;

namespace HierarchyConverter.Wpf.Tests
{
    /// <summary>
    ///This is a test class for IHierarchyAwareTest and is intended
    ///to contain all IHierarchyAwareTest Unit Tests
    ///</summary>
    [TestClass]
    public class IHierarchyAwareTests
    {
        [TestMethod]
        public void ChildrenAreSetForItem()
        {
            var converter = new ReverseHierarchyConverter<MyViewModel, int>(m => m.Id, m => m.ParentId, 0, -1);
            var source = MyViewModel.Gernerate();
            converter.ItemsSource = source;

            var item = source.First();
            var called = 0;
            item.OnSetChildren = (items, sender) => 
                {
                    Assert.AreEqual(sender, converter);
                    called++;
                };

            converter.Convert(item, typeof(IEnumerable), null, null);

            Assert.AreEqual(1, called);
        }
    }
}
