﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections;
using System.Collections.ObjectModel;

namespace HierarchyConverter.Wpf.Tests
{
    public class MyViewModel : IHierarchyAware, INotifyPropertyChanged
    {

        public static IList<MyViewModel> Gernerate()
        {
            ObservableCollection<MyViewModel> originalSource = new ObservableCollection<MyViewModel>()
			{
				new MyViewModel(){ Id = 1, ParentId = 0 },
				new MyViewModel(){ Id = 2, ParentId = 0 },
				new MyViewModel(){ Id = 3, ParentId = 1 },
				new MyViewModel(){ Id = 4, ParentId = 1 },
				new MyViewModel(){ Id = 5, ParentId = 2 },
				new MyViewModel(){ Id = 6, ParentId = 2 },
				new MyViewModel(){ Id = 7, ParentId = 4 },
                new MyViewModel(){ Id = 8, ParentId = 4 },
                new MyViewModel(){ Id = 9, ParentId = -1 },
                new MyViewModel(){ Id = 10, ParentId = -1 },
                new MyViewModel(){ Id = 11, ParentId = 4 },
                new MyViewModel(){ Id = 12, ParentId = 4 },
			};
            foreach (var item in originalSource)
            {
                item.TimesPropertyChanged = 0;
            }
            return originalSource;
        }


        private int parentId;
        /// <summary>
        /// Gets or sets the id of the parent of the object.
        /// </summary>
        public int ParentId
        {
            get
            {
                return this.parentId;
            }
            set
            {
                if (this.parentId != value)
                {
                    this.parentId = value;
                    OnPropertyChanged("ParentId");
                    OnPropertyChanged("Title");
                }
            }
        }

		

        private int id;
        /// <summary>
        /// Gets or sets the id of the object.
        /// </summary>
        public int Id
        {
            get
            {
                return this.id;
            }
            set
            {
                if (this.id != value)
                {
                    this.id = value;
                    OnPropertyChanged("Id");
                    OnPropertyChanged("Title");
                }
            }
        }

        /// <summary>
        /// Gets or sets the title of the object.
        /// </summary>
        public string Title
        {
            get
            {
                return string.Format("Id: {0}, Parent: {1}", Id, ParentId);
            }
        }

        /// <summary>
        ///     Called when the value of a property changes.
        /// </summary>
        /// <param name="propertyName">The name of the property that has changed.</param>
        protected void OnPropertyChanged(String propertyName)
        {
            if (String.IsNullOrEmpty(propertyName))
            {
                return;
            }
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        /// <summary>
        ///     Raised when the value of one of the properties changes.
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;

        public void SetChildren(IEnumerable children, object converter)
        {
            if (OnSetChildren != null)
            {
                OnSetChildren(children, converter);
            }
        }

        public Action<IEnumerable, object> OnSetChildren
        {
            get;
            set;
        }

        public int TimesPropertyChanged { get; set; }

        public int wrongId;

        public int WrongParentId
        {
            get;
            private set;
        }
    }
}
