﻿//-----------------------------------------------------------------------
// <copyright file="IHierarchyAware.cs" company="Telerik">
//     Copyright (c) Telerik.
// </copyright>
// <author>Miroslav Paskov</author>
//-----------------------------------------------------------------------

namespace HierarchyConverter
{
    using System.Collections;

    /// <summary>
    /// This interface should be implemented by all ViewModels that want to have
    /// their children collection assigned when it is generated by the ReverseHierarchyConverter.
    /// </summary>
    public interface IHierarchyAware
    {
        /// <summary>
        /// Called when the items collection of a given item has been generated.
        /// </summary>
        /// <param name="children">The children collection of the item.</param>
        /// <param name="converter">The converter that has generated the given children collection.</param>
        void SetChildren(IEnumerable children, object converter);
    }
}
