﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.ComponentModel
Imports System.Collections

Public Class ViewModelBase
    Implements INotifyPropertyChanged

    Protected Sub SetProperty(Of T)(ByVal propertyName As String, ByRef field As T, ByVal value As T)
        If Not Object.Equals(field, value) Then
            field = value
            OnPropertyChanged(propertyName)
        End If
    End Sub

    ''' <summary>
    ''' Event for INotifyPropertyChanged.
    ''' </summary>
    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    ''' <summary>
    ''' Raises the INotifyPropertyChanged event.
    ''' </summary>
    ''' <param name="propertyName">The property to be included in the INotifyPropertyChanged EventArgs.</param>
    Protected Sub OnPropertyChanged(ByVal propertyName As [String])
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
    End Sub

End Class
