﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;

namespace HierarchyConverter.Wpf.Sample.ViewModels
{
	public class DelegateCommand : ICommand
	{
		private Action executedCallback;
		private Func<bool> canExecuteCallback;

		public DelegateCommand(Action onExecuted)
			: this(onExecuted, null)
		{
		}


		public DelegateCommand(Action onExecuted, Func<bool> canExecute)
		{
			executedCallback = onExecuted;
			canExecuteCallback = canExecute;
		}

		public bool CanExecute(object parameter)
		{
			if(canExecuteCallback == null)
			{
				return false;
			}
			this.CanCommandExecute = canExecuteCallback();
			return this.CanCommandExecute;
		}

		private bool canExecute;
		public bool CanCommandExecute
		{
			get
			{
				return this.canExecute;
			}
			set
			{
				if(this.canExecute != value)
				{
					this.canExecute = value;
					if(this.CanExecuteChanged != null)
					{
						this.CanExecuteChanged(this, EventArgs.Empty);
					}
				}
			}
		}

		public event EventHandler CanExecuteChanged;

		public void Execute(object parameter)
		{
			if(this.executedCallback != null)
			{
				this.executedCallback();
			}
		}
	}

}
