﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections;

namespace HierarchyConverter.Wpf.Sample.ViewModels
{
	public class ViewModelBase : INotifyPropertyChanged
	{
		protected void SetProperty<T>(string propertyName, ref T field, T value)
		{
			if (!object.Equals(field, value))
			{
				field = value;
				OnPropertyChanged(propertyName);
			}
		}

		/// <summary>
		///     Event for INotifyPropertyChanged.
		/// </summary>
		public event PropertyChangedEventHandler PropertyChanged;

		/// <summary>
		///     Raises the INotifyPropertyChanged event.
		/// </summary>
		/// <param name="propertyName">The property to be included in the INotifyPropertyChanged EventArgs.</param>
		protected void OnPropertyChanged(String propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
}
